import base64
import json

from aws_lambda_powertools import Logger
from aws_lambda_powertools.utilities.data_classes import (
    EventBridgeEvent,
    event_source,
)
from aws_lambda_powertools.utilities.typing import LambdaContext
from layercake.email_ import Message
from layercake.strutils import first_word

from boto3clients import sesv2_client
from config import EMAIL_SENDER

SUBJECT = '{first_name}, redefina sua senha na EDUSEG®'
MESSAGE = """
Oi {first_name}, tudo bem?<br/><br/>

Recebemos sua solicitação para redefinir sua senha na EDUSEG®.<br/>
Para continuar, é só clicar no link abaixo:<br/><br/>

<a href="https://id.saladeaula.digital/reset/{token}">
    👉 Clique aqui para redefinir sua senha
</a>
<br/><br/>

Se você não usar este link em até 3 horas, ele expirará.
<a href="https://id.saladeaula.digital/forgot">
    Obter um novo link de redefinição de senha.
</a>
<br/><br/>

Se você não pediu essa redefinição, pode ignorar esta mensagem.
"""

logger = Logger(__name__)


@event_source(data_class=EventBridgeEvent)
def lambda_handler(event: EventBridgeEvent, context: LambdaContext) -> bool:
    new_image = event.detail['new_image']
    first_name = first_word(new_image['name'])
    # Key pattern `CODE#{code}`
    *_, code = new_image['sk'].split('#')
    token = base64.urlsafe_b64encode(
        json.dumps(
            {
                'user_id': new_image['user_id'],
                'code': code,
            }
        ).encode()
    ).decode()

    emailmsg = Message(
        from_=EMAIL_SENDER,
        to=(new_image['name'], new_image['email']),
        subject=SUBJECT.format(
            first_name=first_name,
        ),
    )
    emailmsg.add_alternative(
        MESSAGE.format(
            first_name=first_name,
            token=token,
        )
    )

    try:
        sesv2_client.send_email(
            Content={
                'Raw': {
                    'Data': emailmsg.as_bytes(),
                },
            }
        )
        logger.info('Email sent')
    except Exception as exc:
        logger.exception(exc)
        return False
    else:
        return True
